'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var BubbleSidebarActiveItemContext = React__default.createContext({
  background: '#000',
  activeIndex: 0,
  activeColor: '#000',
  makeItemActive: function makeItemActive() {
    return function () {};
  }
});

var Header =
/*#__PURE__*/
function (_Component) {
  _inherits(Header, _Component);

  function Header() {
    _classCallCheck(this, Header);

    return _possibleConstructorReturn(this, _getPrototypeOf(Header).apply(this, arguments));
  }

  _createClass(Header, [{
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          avatar = _this$props.avatar,
          text = _this$props.text;
      return React__default.createElement(BubbleSidebarActiveItemContext.Consumer, null, function (_ref) {
        var background = _ref.background,
            activeIndex = _ref.activeIndex,
            activeColor = _ref.activeColor,
            makeItemActive = _ref.makeItemActive;
        return React__default.createElement("div", {
          className: "header",
          style: {
            color: _this.props.index === activeIndex ? activeColor : '',
            background: background === 'transparent' ? _this.props.index !== activeIndex ? _this.props.background : '' : ''
          },
          onClick: makeItemActive(_this.props.index)
        }, avatar && React__default.createElement("img", {
          src: avatar,
          alt: ""
        }), text && React__default.createElement("div", {
          className: "text"
        }, text));
      });
    }
  }]);

  return Header;
}(React.Component);
Header.propTypes = {
  avatar: PropTypes.string,
  text: PropTypes.string,
  index: PropTypes.number
};
var Item =
/*#__PURE__*/
function (_Component2) {
  _inherits(Item, _Component2);

  function Item() {
    _classCallCheck(this, Item);

    return _possibleConstructorReturn(this, _getPrototypeOf(Item).apply(this, arguments));
  }

  _createClass(Item, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          image = _this$props2.image,
          text = _this$props2.text;
      return React__default.createElement(BubbleSidebarActiveItemContext.Consumer, null, function (_ref2) {
        var background = _ref2.background,
            activeIndex = _ref2.activeIndex,
            activeColor = _ref2.activeColor,
            makeItemActive = _ref2.makeItemActive;
        return React__default.createElement("div", {
          className: "item",
          style: {
            color: _this2.props.index === activeIndex ? activeColor : '',
            background: background === 'transparent' ? _this2.props.index !== activeIndex ? _this2.props.background : '' : ''
          },
          onClick: makeItemActive(_this2.props.index)
        }, image && React__default.createElement("img", {
          src: image,
          alt: ""
        }), text && React__default.createElement("div", {
          className: "text"
        }, text));
      });
    }
  }]);

  return Item;
}(React.Component);
Item.propTypes = {
  image: PropTypes.string,
  text: PropTypes.string,
  index: PropTypes.number
};

var CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS = '5px';
var CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS = '15px';
var CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS = '25px';

function concatClassNamesByCondition(classNames) {
  return classNames.map(function (c) {
    if (c.condition === true) {
      return c.value;
    } else {
      return '';
    }
  }).filter(function (c) {
    return c !== '';
  }).join(' ');
}

var BubbleSidebar =
/*#__PURE__*/
function (_Component) {
  _inherits(BubbleSidebar, _Component);

  function BubbleSidebar(props) {
    var _this;

    _classCallCheck(this, BubbleSidebar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BubbleSidebar).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "makeItemActive", function (index) {
      return function () {
        var prevActiveIndex = _this.state.activeIndex;

        if (_this.moving || index === prevActiveIndex) {
          return;
        }

        _this.setState({
          background: _this.props.background,
          activeIndex: index
        }, function () {
          _this.effectMoveSlider(prevActiveIndex);
        });
      };
    });

    _defineProperty(_assertThisInitialized(_this), "activeItemInfirstRender", function () {
      var sidebarElement = _this.sidebar.current;
      var sliderElement = _this.slider.current;
      var activeIndex = _this.state.activeIndex;
      var sliderTo = sidebarElement.children[activeIndex + 1];
      var moveLength = Array.from(sidebarElement.children).slice(1).slice(0, activeIndex).reduce(function (acc, child) {
        return acc + child.offsetHeight;
      }, 0);

      if (activeIndex === 0) {
        var item = sidebarElement.children[2];

        switch (_this.props.width) {
          case 'thin':
            item.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
            break;

          case 'normal':
            item.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
            break;

          case 'wide':
            item.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
            break;

          default:
            break;
        }

        if (!_this.props.attached) {
          switch (_this.props.width) {
            case 'thin':
              sliderElement.style.borderTopLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              sliderElement.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              break;

            case 'normal':
              sliderElement.style.borderTopLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              sliderElement.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              break;

            case 'wide':
              sliderElement.style.borderTopLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              sliderElement.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              break;

            default:
              break;
          }
        }

        _this.item1 = item;
        _this.item2 = null;
      } else if (activeIndex > 0 && activeIndex < sidebarElement.children.length - 2) {
        var item1 = sidebarElement.children[activeIndex];
        var item2 = sidebarElement.children[activeIndex + 2];

        switch (_this.props.width) {
          case 'thin':
            item1.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
            item2.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
            break;

          case 'normal':
            item1.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
            item2.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
            break;

          case 'wide':
            item1.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
            item2.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
            break;

          default:
            break;
        }

        _this.item1 = item1;
        _this.item2 = item2;
      } else {
        var _item = sidebarElement.children[sidebarElement.children.length - 2];

        switch (_this.props.width) {
          case 'thin':
            _item.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
            break;

          case 'normal':
            _item.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
            break;

          case 'wide':
            _item.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
            break;

          default:
            break;
        }

        if (!_this.props.attached) {
          switch (_this.props.width) {
            case 'thin':
              sliderElement.style.borderBottomLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              sliderElement.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              break;

            case 'normal':
              sliderElement.style.borderBottomLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              sliderElement.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              break;

            case 'wide':
              sliderElement.style.borderBottomLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              sliderElement.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              break;

            default:
              break;
          }
        }

        _this.item1 = _item;
        _this.item2 = null;
      }

      sliderElement.style.top = "".concat(moveLength, "px");
      sliderElement.style.width = "".concat(sliderTo.offsetWidth, "px");
      sliderElement.style.height = "".concat(sliderTo.offsetHeight, "px");
    });

    _defineProperty(_assertThisInitialized(_this), "effectMoveSlider", function (prevActiveIndex) {
      var activeIndex = _this.state.activeIndex;
      _this.moving = true;

      if (_this.item1 !== null) {
        _this.item1.style.borderTopRightRadius = '';
        _this.item1.style.borderBottomRightRadius = '';
      }

      if (_this.item2 !== null) {
        _this.item2.style.borderTopRightRadius = '';
        _this.item2.style.borderBottomRightRadius = '';
      }

      var sidebarElement = _this.sidebar.current;
      var sliderElement = _this.slider.current;
      var sliderTo = sidebarElement.children[activeIndex + 1];
      var sliderTop = parseInt(sliderElement.style.top);
      var minIndex = Math.min(prevActiveIndex, activeIndex);
      var maxIndex = Math.max(prevActiveIndex, activeIndex);
      var moveLength = Array.from(sidebarElement.children).slice(1).slice(minIndex, maxIndex).reduce(function (acc, child) {
        return acc + child.offsetHeight;
      }, 0);

      var moveChange = function moveChange() {
        if (activeIndex === 0) {
          var item = sidebarElement.children[2];

          switch (_this.props.width) {
            case 'thin':
              item.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              break;

            case 'normal':
              item.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              break;

            case 'wide':
              item.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              break;

            default:
              break;
          }

          _this.item1 = item;
          _this.item2 = null;
        } else if (activeIndex > 0 && activeIndex < sidebarElement.children.length - 2) {
          var item1 = sidebarElement.children[activeIndex];
          var item2 = sidebarElement.children[activeIndex + 2];

          switch (_this.props.width) {
            case 'thin':
              item1.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              item2.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              break;

            case 'normal':
              item1.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              item2.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              break;

            case 'wide':
              item1.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              item2.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              break;

            default:
              break;
          }

          _this.item1 = item1;
          _this.item2 = item2;
        } else {
          var _item2 = sidebarElement.children[sidebarElement.children.length - 2];

          switch (_this.props.width) {
            case 'thin':
              _item2.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              break;

            case 'normal':
              _item2.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              break;

            case 'wide':
              _item2.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              break;

            default:
              break;
          }

          _this.item1 = _item2;
          _this.item2 = null;
        }

        _this.moving = false;
      };

      if (activeIndex === 0) {
        if (!_this.props.attached) {
          switch (_this.props.width) {
            case 'thin':
              sliderElement.style.borderTopLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              sliderElement.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              break;

            case 'normal':
              sliderElement.style.borderTopLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              sliderElement.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              break;

            case 'wide':
              sliderElement.style.borderTopLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              sliderElement.style.borderTopRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              break;

            default:
              break;
          }
        }
      } else if (activeIndex > 0 && activeIndex < sidebarElement.children.length - 2) {
        sliderElement.style.borderTopLeftRadius = 0;
        sliderElement.style.borderTopRightRadius = 0;
        sliderElement.style.borderBottomLeftRadius = 0;
        sliderElement.style.borderBottomRightRadius = 0;
      } else {
        if (!_this.props.attached) {
          switch (_this.props.width) {
            case 'thin':
              sliderElement.style.borderBottomLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              sliderElement.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_THIN_RADIUS;
              break;

            case 'normal':
              sliderElement.style.borderBottomLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              sliderElement.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_NORMAL_RADIUS;
              break;

            case 'wide':
              sliderElement.style.borderBottomLeftRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              sliderElement.style.borderBottomRightRadius = CREATIVE_CP_BUBBLE_SIDEBAR_WIDE_RADIUS;
              break;

            default:
              break;
          }
        }
      }

      if (activeIndex > prevActiveIndex) {
        sliderElement.style.top = "".concat(sliderTop + moveLength, "px");
      } else {
        sliderElement.style.top = "".concat(sliderTop - moveLength, "px");
      }

      sliderElement.style.width = "".concat(sliderTo.offsetWidth, "px");
      sliderElement.style.height = "".concat(sliderTo.offsetHeight, "px");
      setTimeout(function () {
        _this.setState({
          background: 'transparent'
        }, function () {
          moveChange();
          _this.props.onClick && _this.props.onClick();
        });
      }, 500);
    });

    _this.state = {
      background: 'transparent',
      activeIndex: props.activeIndex,
      activeColor: props.activeColor,
      makeItemActive: _this.makeItemActive
    };
    _this.sidebar = React__default.createRef();
    _this.slider = React__default.createRef();
    _this.moving = false;
    return _this;
  }

  _createClass(BubbleSidebar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.activeItemInfirstRender();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          attached = _this$props.attached,
          color = _this$props.color,
          width = _this$props.width,
          sliderBackground = _this$props.sliderBackground;
      var background = this.state.background;
      var wrapperClassName = concatClassNamesByCondition([{
        value: 'creative-cp-bubble-sidebar-wrapper',
        condition: true
      }, {
        value: 'attached',
        condition: attached
      }, {
        value: width,
        condition: true
      }]);
      var sidebarClassName = concatClassNamesByCondition([{
        value: 'creative-cp-bubble-sidebar',
        condition: true
      }, {
        value: width,
        condition: true
      }]);
      var sliderClassName = concatClassNamesByCondition([{
        value: 'slider',
        condition: true
      }]);
      var children = React__default.Children.map(this.props.children, function (child, index) {
        return React__default.cloneElement(child, {
          index: index,
          background: _this2.props.background
        });
      });
      return React__default.createElement("div", {
        className: wrapperClassName,
        style: {
          background: sliderBackground
        }
      }, React__default.createElement("div", {
        ref: this.sidebar,
        className: sidebarClassName,
        style: {
          color: color,
          background: background
        }
      }, React__default.createElement("div", {
        ref: this.slider,
        className: sliderClassName,
        style: {
          background: sliderBackground
        }
      }), React__default.createElement(BubbleSidebarActiveItemContext.Provider, {
        value: this.state
      }, children)));
    }
  }]);

  return BubbleSidebar;
}(React.Component);

_defineProperty(BubbleSidebar, "defaultProps", {
  attached: false,
  width: 'normal',
  color: '#fff',
  background: '#000',
  sliderBackground: '#fff',
  activeIndex: 0,
  activeColor: '#000'
});

BubbleSidebar.propTypes = {
  attached: PropTypes.bool,
  width: PropTypes.oneOf(['thin', 'normal', 'wide']),
  color: PropTypes.string,
  background: PropTypes.string,
  sliderBackground: PropTypes.string,
  activeIndex: PropTypes.number,
  activeColor: PropTypes.string,
  onClick: PropTypes.func
};
BubbleSidebar.Header = Header;
BubbleSidebar.Item = Item;

module.exports = BubbleSidebar;
