import React, { Component } from 'react'
import PropTypes from 'prop-types'
import { BubbleSidebarActiveItemContext } from './context'

export class Header extends Component {
  render() {
    const { avatar, text } = this.props

    return (
      <BubbleSidebarActiveItemContext.Consumer>
        {({ background, activeIndex, activeColor, makeItemActive }) => (
          <div
            className="header"
            style={{
              color: this.props.index === activeIndex ? activeColor : '',
              background:
                background === 'transparent'
                  ? this.props.index !== activeIndex
                    ? this.props.background
                    : ''
                  : ''
            }}
            onClick={makeItemActive(this.props.index)}
          >
            {avatar && <img src={avatar} alt="" />}
            {text && <div className="text">{text}</div>}
          </div>
        )}
      </BubbleSidebarActiveItemContext.Consumer>
    )
  }
}

Header.propTypes = {
  avatar: PropTypes.string,
  text: PropTypes.string,
  index: PropTypes.number
}

export class Item extends Component {
  render() {
    const { image, text } = this.props

    return (
      <BubbleSidebarActiveItemContext.Consumer>
        {({ background, activeIndex, activeColor, makeItemActive }) => (
          <div
            className="item"
            style={{
              color: this.props.index === activeIndex ? activeColor : '',
              background:
                background === 'transparent'
                  ? this.props.index !== activeIndex
                    ? this.props.background
                    : ''
                  : ''
            }}
            onClick={makeItemActive(this.props.index)}
          >
            {image && <img src={image} alt="" />}
            {text && <div className="text">{text}</div>}
          </div>
        )}
      </BubbleSidebarActiveItemContext.Consumer>
    )
  }
}

Item.propTypes = {
  image: PropTypes.string,
  text: PropTypes.string,
  index: PropTypes.number
}
